#!/bin/sh
#==============================================================================
#
# CIOS Get Strage Information from esxcfg-info command result on VMware ESX
# Copyright FUJITSU LIMITED 2010
#
#==============================================================================
# 2010.01.04 new create
#==============================================================================
# $Name: SLINPSA-2_0_4-0 $
#==============================================================================


#==============================================================================
# initialize parametors
#==============================================================================
line=""
tmp=""
logfile=""

depth_Storage_Info=""
depth_All_SCSI_Iface=""
depth_FibreChannel_SCSI_Interface=""
depth_SerialAttached_SCSI_Interface=""
depth_Parallel_SCSI_Interface=""
depth_SCSI_Interface=""
depth_PCI_Device=""
depth_Paths=""
depth_Scsi_Path=""
depth_Disk_Lun=""
depth_LUN=""

baseDepth=""
curDepth=""

val_bus=""
val_slot=""
val_function=""
val_channel=""
val_target=""
val_lun=""
val_type=""
val_vendor=""
val_model=""
val_revision=""
val_console_device=""

# define parametor values
CategoryType_Storage_Info=0
CategoryType_All_SCSI_Iface=1
CategoryType_FibreChannel_SCSI_Interface=2
CategoryType_SerialAttached_SCSI_Interface=3
CategoryType_Parallel_SCSI_Interface=4
CategoryType_SCSI_Interface=5
CategoryType_PCI_Device=6
CategoryType_Paths=7
CategoryType_Scsi_Path=8
CategoryType_Disk_Lun=9
CategoryType_LUN=10

MemberType_Bus=11
MemberType_Slot=12
MemberType_Function=13
MemberType_Channel=14
MemberType_Target=15
MemberType_Lun=16
MemberType_Type=17
MemberType_Vendor=18
MemberType_Model=19
MemberType_Revision=20
MemberType_Console_Device=21

# parametor change to readonly type
readonly CategoryType_Storage_Info
readonly CategoryType_All_SCSI_Iface
readonly CategoryType_FibreChannel_SCSI_Interface
readonly CategoryType_SerialAttached_SCSI_Interface
readonly CategoryType_Parallel_SCSI_Interface
readonly CategoryType_SCSI_Interface
readonly CategoryType_PCI_Device
readonly CategoryType_Paths
readonly CategoryType_Scsi_Path
readonly CategoryType_Disk_Lun
readonly CategoryType_LUN

readonly MemberType_Bus
readonly MemberType_Slot
readonly MemberType_Function
readonly MemberType_Channel
readonly MemberType_Target
readonly MemberType_Lun
readonly MemberType_Type
readonly MemberType_Vendor
readonly MemberType_Model
readonly MemberType_Revision
readonly MemberType_Console_Device
#
#==============================================================================
# print_log()
#
# outline
#   output log to log file
#
# parameter
#   none
#
# return value
#   none
#==============================================================================
print_log()
{
	echo "$1" >> $logfile
}
#
#==============================================================================
# print_data()
#
# outline
#   output storage information
#
# parameter
#   none
#
# return value
#   none
#==============================================================================
print_data()
{
	judgeValues
	if [ $? -eq 0 ] ; then
		echo -n "$val_bus"	# Bus
		echo -n ":"
		echo -n "$val_slot"	# Slot
		echo -n "."
		echo -n "$val_function"	# Function
		echo -n ","
		echo -n "$val_channel"	# Channel
		echo -n ":"
		echo -n "$val_target"	# Target
		echo -n ":"
		echo -n "$val_lun"	# Lun
		echo -n ","
		echo -n "$val_type"	# Type
		echo -n ","
		echo -n "$val_vendor"	# Vendor
		echo -n ","
		echo -n "$val_model"	# Model
		echo -n ","
		echo -n "$val_revision"	# Revision
		echo -n ","
		echo -n "$val_console_device"	# Console Device
		echo ""
	fi
}
#
#==============================================================================
# getDepth()
#
# outline
#   getting depth
#
# parameter
#   strings
#
# return value
#   number of space charactor(depth)
#==============================================================================
getDepth()
{
	chars=`echo "$1" | sed "s/^\([[:space:]]*\).*/\1/"`
	return ${#chars}
}
#
#==============================================================================
# judgeMember()
#
# outline
#   judge type of member
#
# parameter
#   strings
#
# return value
#   -1   : not matched
#   other: type fo member
#==============================================================================
judgeMember()
{
	echo "$1" | grep '|----Bus\.' > /dev/null
	if [ $? -eq 0 ] ; then
		return $MemberType_Bus
	fi

	echo "$1" | grep '|----Slot\.' > /dev/null
	if [ $? -eq 0 ] ; then
		return $MemberType_Slot
	fi

	echo "$1" | grep '|----Function\.' > /dev/null
	if [ $? -eq 0 ] ; then
		return $MemberType_Function
	fi

	echo "$1" | grep '|----Channel\.' > /dev/null
	if [ $? -eq 0 ] ; then
		return $MemberType_Channel
	fi

	echo "$1" | grep '|----Target\.' > /dev/null
	if [ $? -eq 0 ] ; then
		return $MemberType_Target
	fi

	echo "$1" | grep '|----Lun\.' > /dev/null
	if [ $? -eq 0 ] ; then
		return $MemberType_Lun
	fi

	echo "$1" | grep '|----Type\.' > /dev/null
	if [ $? -eq 0 ] ; then
		return $MemberType_Type
	fi

	echo "$1" | grep '|----Vendor\.' > /dev/null
	if [ $? -eq 0 ] ; then
		return $MemberType_Vendor
	fi

	echo "$1" | grep '|----Model\.' > /dev/null
	if [ $? -eq 0 ] ; then
		return $MemberType_Model
	fi

	echo "$1" | grep '|----Revision\.' > /dev/null
	if [ $? -eq 0 ] ; then
		return $MemberType_Revision
	fi

	echo "$1" | grep '|----Console Device\.' > /dev/null
	if [ $? -eq 0 ] ; then
		return $MemberType_Console_Device
	fi

	return -1
}
#
#==============================================================================
# judgeCategory()
#
# outline
#   judge type of category
#
# parameter
#   string
#
# return value
#   -1   : not matched
#   other: type fo category
#==============================================================================
judgeCategory()
{
	echo "$1" | grep 'Storage Info :' > /dev/null
	if [ $? -eq 0 ] ; then
		return $CategoryType_Storage_Info
	fi

	echo "$1" | grep 'All SCSI Iface :' > /dev/null
	if [ $? -eq 0 ] ; then
		return $CategoryType_All_SCSI_Iface
	fi

	echo "$1" | grep 'FibreChannel SCSI Interface :' > /dev/null
	if [ $? -eq 0 ] ; then
		return $CategoryType_FibreChannel_SCSI_Interface
	fi

	echo "$1" | grep 'SerialAttached SCSI Interface :' > /dev/null
	if [ $? -eq 0 ] ; then
		return $CategoryType_SerialAttached_SCSI_Interface
	fi

	echo "$1" | grep 'Parallel SCSI Interface :' > /dev/null
	if [ $? -eq 0 ] ; then
		return $CategoryType_Parallel_SCSI_Interface
	fi

	echo "$1" | grep 'SCSI Interface :' > /dev/null
	if [ $? -eq 0 ] ; then
		return $CategoryType_SCSI_Interface
	fi

	echo "$1" | grep 'PCI Device :' > /dev/null
	if [ $? -eq 0 ] ; then
		return $CategoryType_PCI_Device
	fi

	echo "$1" | grep 'Paths :' > /dev/null
	if [ $? -eq 0 ] ; then
		return $CategoryType_Paths
	fi

	echo "$1" | grep 'Scsi Path :' > /dev/null
	if [ $? -eq 0 ] ; then
		return $CategoryType_Scsi_Path
	fi

	echo "$1" | grep 'Disk Lun :' > /dev/null
	if [ $? -eq 0 ] ; then
		return $CategoryType_Disk_Lun
	fi

	echo "$1" | grep 'LUN :' > /dev/null
	if [ $? -eq 0 ] ; then
		return $CategoryType_LUN
	fi

	return -1
}
#
#==============================================================================
# judgeValues()
#
# outline
#   judge whether needed values are not empty
#
# parameter
#   none
#
# return value
#   0: all parametors are not empty
#   1: at least 1 parametor is empty
#==============================================================================
judgeValues()
{
	if [ -n "$val_bus" -a \
		 -n "$val_slot" -a \
		 -n "$val_function" -a \
		 -n "$val_channel" -a \
		 -n "$val_target" -a \
		 -n "$val_lun" \
		] ; then
		# all values are set
		return 0
	fi
	
	# else
	return 1
}
#
#==============================================================================
# trim_space()
#
# outline
#   triming head/tail space charactors from given string
#
# parameter
#   string
#
# return value
#   none
#==============================================================================
trim_space()
{
	tmp="`echo \"$1\" | sed -e \"s/^[[:space:]]*//g\" -e \"s/[[:space:]]*$//g\"`"
}
#
#==============================================================================
# work_LUN()
#
# outline
#   work at "LUN" category to get storage detail information
#
# parameter
#   none
#
# return value
#   none
#==============================================================================
work_LUN()
{
	# clear values
	val_type=""
	val_vendor=""
	val_model=""
	val_revision=""
	val_console_device=""
	
	while read line
	  do
	  getDepth "$line"
	  curDepth=$?
	  if [ $curDepth -le $depth_LUN ] ; then
		  print_data
		  return
	  fi

	  judgeMember "$line"
	  case $? in
		  $MemberType_Type ) # Type
			  print_log "$line"
			  val_type="`echo \"$line\" | sed \"s/.*Type\.*\(.*\)/\1/\"`"
			  trim_space "$val_type"
			  val_type="$tmp"
			  ;;
		  $MemberType_Vendor ) # Vendor
			  print_log "$line"
			  val_vendor="`echo \"$line\" | sed \"s/.*Vendor\.*\(.*\)/\1/\"`"
			  trim_space "$val_vendor"
			  val_vendor="$tmp"
			  ;;
		  $MemberType_Model ) # Model
			  print_log "$line"
			  val_model="`echo \"$line\" | sed \"s/.*Model\.*\(.*\)/\1/\"`"
			  trim_space "$val_model"
			  val_model="$tmp"
			  ;;
		  $MemberType_Revision ) # Revision
			  print_log "$line"
			  val_revision="`echo \"$line\" | sed \"s/.*Revision\.*\(.*\)/\1/\"`"
			  trim_space "$val_revision"
			  val_revision="$tmp"
			  ;;
		  $MemberType_Console_Device ) # Console Device
			  print_log "$line"
			  val_console_device="`echo \"$line\" | sed \"s/.*Console Device\.*\(.*\)/\1/\"`"
			  trim_space "$val_console_device"
			  val_console_device="$tmp"
			  ;;
	  esac
	done

	print_data

	exit -10	# EOF
}
#
#==============================================================================
# work_Disk_Lun()
#
# outline
#   work at "Disk Lun" category
#
# parameter
#   none
#
# return value
#   none
#==============================================================================
work_Disk_Lun()
{
	Disk_Lun_readSkip="OFF"
	while :
	  do
	  if [ $Disk_Lun_readSkip == "OFF" ] ; then
		  read line
		  if [ $? -ne 0 ] ; then
			  exit -9	# EOF
		  fi
	  else
		  Disk_Lun_readSkip="OFF"
	  fi

	  getDepth "$line"
	  curDepth=$?
	  if [ $curDepth -le $depth_Disk_Lun ] ; then
		  return
	  fi

	  judgeCategory "$line"
	  case $? in
		  $CategoryType_LUN )
			  print_log "$line"
			  getDepth $line
			  depth_LUN=$?
			  work_LUN
			  Disk_Lun_readSkip="ON"
			  ;;
	  esac
		  
	done

	# never reach here
}
#
#==============================================================================
# work_Scsi_Path()
#
# outline
#   work at "Scsi Path" category to get chan/target/lun information
#
# parameter
#   none
#
# return value
#   none
#==============================================================================
work_Scsi_Path()
{
	# clear values
	val_channel=""
	val_target=""
	val_lun=""

	Scsi_Path_readSkip="OFF"
	while :
	  do
	  if [ $Scsi_Path_readSkip == "OFF" ] ; then
		  read line
		  if [ $? -ne 0 ] ; then
			  exit -8	# EOF
		  fi
	  else
		  Scsi_Path_readSkip="OFF"
	  fi

	  getDepth "$line"
	  curDepth=$?
	  if [ $curDepth -le $depth_Scsi_Path ] ; then
		  return
	  fi

	  judgeMember "$line"
	  case $? in
		  $MemberType_Channel )
			  print_log "$line"
			  val_channel="`echo \"$line\" | sed \"s/.*Channel\.*\(.*\)/\1/\"`"
			  trim_space "$val_channel"
			  val_channel="$tmp"
			  continue
			  ;;
		  $MemberType_Target )
			  print_log "$line"
			  val_target="`echo \"$line\" | sed \"s/.*Target\.*\(.*\)/\1/\"`"
			  trim_space "$val_target"
			  val_target="$tmp"
			  continue
			  ;;
		  $MemberType_Lun )
			  print_log "$line"
			  val_lun="`echo \"$line\" | sed \"s/.*Lun\.*\(.*\)/\1/\"`"
			  trim_space "$val_lun"
			  val_lun="$tmp"
			  continue
			  ;;
	  esac
	  
	  judgeCategory "$line"
	  case $? in
		  $CategoryType_Disk_Lun )
			  print_log "$line"
			  getDepth "$line"
			  depth_Disk_Lun=$?
			  work_Disk_Lun
			  Scsi_Path_readSkip="ON"
			  ;;
	  esac

	done

	# never reach here
}
#
#==============================================================================
# work_Paths()
#
# outline
#   work at "Paths" category
#
# parameter
#   none
#
# return value
#   none
#==============================================================================
work_Paths()
{
	Paths_readSkip="OFF"
	while :
	  do
	  if [ $Paths_readSkip == "OFF" ] ; then
		  read line
		  if [ $? -ne 0 ] ; then
			  exit -7	# EOF
		  fi
	  else
		  Paths_readSkip="OFF"
	  fi

	  getDepth "$line"
	  curDepth=$?
	  if [ $curDepth -le $depth_Paths ] ; then
		  return
	  fi

	  judgeCategory "$line"
	  case $? in
		  $CategoryType_Scsi_Path )
			  print_log "$line"
			  getDepth $line
			  depth_Scsi_Path=$?
			  work_Scsi_Path
			  Paths_readSkip="ON"
			  ;;
	  esac
	done

	# never reach here
}
#
#==============================================================================
# work_PCI_Device()
#
# outline
#   work at "PCI Device" category to get bus information
#
# parameter
#   none
#
# return value
#   none
#==============================================================================
work_PCI_Device()
{
	# clear values
	val_bus=""
	val_slot=""
	val_function=""

	while read line
	  do
	  getDepth "$line"
	  curDepth=$?
	  if [ $curDepth -le $depth_PCI_Device ] ; then
		  return
	  fi

	  judgeMember "$line"
	  case $? in
		  $MemberType_Bus ) # Bus
			  print_log "$line"
			  val_bus="`echo \"$line\" | sed \"s/.*Bus\.*\(.*\)/\1/\"`"
			  trim_space "$val_bus"
			  val_bus="$tmp"
			  ;;
		  $MemberType_Slot ) # Slot
			  print_log "$line"
			  val_slot="`echo \"$line\" | sed \"s/.*Slot\.*\(.*\)/\1/\"`"
			  trim_space "$val_slot"
			  val_slot="$tmp"
			  ;;
		  $MemberType_Function ) # Function
			  print_log "$line"
			  val_function="`echo \"$line\" | sed \"s/.*Function\.*\(.*\)/\1/\"`"
			  trim_space "$val_function"
			  val_function="$tmp"
			  ;;
	  esac
	done

	exit -6	# EOF
}
#
#==============================================================================
# work_SCSI_Interface()
#
# outline
#   work at "SCSI Interface" category
#
# parameter
#   none
#
# return value
#   none
#==============================================================================
work_SCSI_Interface()
{
	baseDepth=$1

	SCSI_Interface_readSkip="OFF"
	while :
	  do
	  if [ $SCSI_Interface_readSkip == "OFF" ] ; then
		  read line
		  if [ $? -ne 0 ] ; then
			  exit -5	# EOF
		  fi
	  else
		  SCSI_Interface_readSkip="OFF"
	  fi

	  getDepth "$line"
	  curDepth=$?
	  if [ $curDepth -le $baseDepth ] ; then
		  return
	  fi

	  judgeCategory "$line"
	  case $? in
		  $CategoryType_PCI_Device ) # PCI Device
			  print_log "$line"
			  getDepth "$line"
			  depth_PCI_Device=$?
			  work_PCI_Device
			  SCSI_Interface_readSkip="ON"
			  ;;
		  $CategoryType_Paths ) # Paths
			  print_log "$line"
			  getDepth "$line"
			  depth_Paths=$?
			  work_Paths
			  SCSI_Interface_readSkip="ON"
			  ;;
	  esac
	done

	# never reach here
}
#
#==============================================================================
# work_FibreChannel_SCSI_Interface()
#
# outline
#   work at "FibreChannel SCSI Interface"
#
# parameter
#   none
#
# return value
#   none
#==============================================================================
work_FibreChannel_SCSI_Interface()
{
	while read line
	  do
	  getDepth "$line"
	  curDepth=$?
	  if [ $curDepth -le $depth_FibreChannel_SCSI_Interface ] ; then
		  return
	  fi
	  
	  judgeCategory "$line"
	  case $? in
		  $CategoryType_SCSI_Interface )
			  print_log "$line"
			  getDepth "$line"
			  depth_SCSI_Interface=$?
			  work_SCSI_Interface $depth_SCSI_Interface
			  return
			  ;;
	  esac
	done

	exit -4	# EOF
}
#
#==============================================================================
# work_Parallel_SCSI_Interface()
#
# outline
#   work at "Parallel SCSI Interface"
#
# parameter
#   none
#
# return value
#   none
#==============================================================================
work_Parallel_SCSI_Interface()
{
	while read line
	  do
	  getDepth "$line"
	  curDepth=$?
	  if [ $curDepth -le $depth_Parallel_SCSI_Interface ] ; then
		  return
	  fi
	  
	  judgeCategory "$line"
	  case $? in
		  $CategoryType_SCSI_Interface )
			  print_log "$line"
			  getDepth "$line"
			  depth_SCSI_Interface=$?
			  work_SCSI_Interface $depth_SCSI_Interface
			  return
			  ;;
	  esac
	done

	exit -3	# EOF
}
#
#==============================================================================
# work_All_SCSI_Iface()
#
# outline
#   work at "All SCSI Iface"
#
# parameter
#   none
#
# return value
#   none
#==============================================================================
work_All_SCSI_Iface()
{
	All_SCSI_Iface_readSkip="OFF"
	while :
	  do
	  if [ $All_SCSI_Iface_readSkip == "OFF" ] ; then
		  read line
		  if [ $? -ne 0 ] ; then
			  exit -2	# EOF
		  fi
	  else
		  All_SCSI_Iface_readSkip="OFF"
	  fi

	  getDepth "$line"
	  curDepth=$?
	  if [ $curDepth -le $depth_All_SCSI_Iface ] ; then
		  exit 2
	  fi

	  judgeCategory "$line"
	  case $? in
		  $CategoryType_FibreChannel_SCSI_Interface )
			  print_log "$line"
			  getDepth "$line"
			  depth_FibreChannel_SCSI_Interface=$?
			  work_FibreChannel_SCSI_Interface
			  All_SCSI_Iface_readSkip="ON"
			  ;;
		  $CategoryType_SerialAttached_SCSI_Interface )
			  ;;
		  $CategoryType_Parallel_SCSI_Interface )
#			  print_log "$line"
#			  getDepth "$line"
#			  depth_Parallel_SCSI_Interface=$?
#			  work_Parallel_SCSI_Interface
#			  All_SCSI_Iface_readSkip="ON"
			  ;;
	  esac
	done

	# never reach here
}
#
#==============================================================================
# work_Storage_Info()
#
# outline
#   work at "Storage Info"
#
# parameter
#   none
#
# return value
#   none
#==============================================================================
work_Storage_Info()
{
	while read line
	  do
	  getDepth "$line"
	  curDepth=$?
	  if [ $curDepth -le $depth_Storage_Info ] ; then
		  exit 1	# not expected route
	  fi

	  judgeCategory "$line"
	  case $? in
		  $CategoryType_All_SCSI_Iface )
			  print_log "$line"
			  getDepth "$line"
			  depth_All_SCSI_Iface=$?
			  work_All_SCSI_Iface	# never return to here
			  ;;
	  esac
	done

	exit -1	# EOF
}
#
#==============================================================================
# main()
#
# outline
#   get storage information 
#
# parameter
#   output log file path
#
# return value
#   always 0
#==============================================================================

# set log output file path
logfile="$1"

# clear log file empty
cat /dev/null > "$logfile"

# change Internal Field Separator to return charactor
IFS='
'

# drop standard error output
exec 2>/dev/null

# find "Storage Info"
while read line
  do
  getDepth "$line"
  depth_Storage_Info=$?

  judgeCategory "$line"
  case $? in
	  $CategoryType_Storage_Info )
		  print_log "$line"
		  work_Storage_Info	# never return to here
		  ;;
  esac
done

exit 0
